| Version: 3.3.1

Public Member Functions | List of all members
wxZipInputStream Class Reference
Class List by Category » Archive support | Class List by Category » Streams

`#include <wx/zipstrm.h>`

Inheritance diagram for wxZipInputStream:
[legend]

## Detailed Description

Input stream for reading zip files.

wxZipInputStream::GetNextEntry() returns a wxZipEntry object containing the meta-data for the next entry in the zip (and gives away ownership). Reading from the wxZipInputStream then returns the entry's data. Eof() becomes true after an attempt has been made to read past the end of the entry's data. When there are no more entries, GetNextEntry() returns nullptr and sets Eof().

Note that in general zip entries are not seekable, and wxZipInputStream::SeekI() always returns wxInvalidOffset.

##

Library: wxBase
Category: Archive support, Streams

See also
  Archive Formats, wxZipEntry, wxZipOutputStream

## Public Member Functions
bool | CloseEntry ()
| Closes the current entry. More...
wxString | GetComment ()
| Returns the zip comment. More...
wxZipEntry * | GetNextEntry ()
| Closes the current entry if one is open, then reads the meta-data for the next entry and returns it in a wxZipEntry object, giving away ownership. More...
int | GetTotalEntries ()
| For a zip on a seekable stream returns the total number of entries in the zip. More...
bool | OpenEntry (wxZipEntry &entry)
| Closes the current entry if one is open, then opens the entry specified by the entry object. More...
| wxZipInputStream (wxInputStream &stream, wxMBConv &conv=wxConvLocal)
| Constructor. More...
| wxZipInputStream (wxInputStream *stream, wxMBConv &conv=wxConvLocal)
| Constructor. More...
Public Member Functions inherited from wxArchiveInputStream
wxArchiveEntry * | GetNextEntry ()
| Closes the current entry if one is open, then reads the meta-data for the next entry and returns it in a wxArchiveEntry object, giving away ownership. More...
virtual bool | OpenEntry (wxArchiveEntry &entry)=0
| Closes the current entry if one is open, then opens the entry specified by the wxArchiveEntry object. More...
Public Member Functions inherited from wxFilterInputStream
| wxFilterInputStream (wxInputStream &stream)
| Initializes a "filter" stream. More...
| wxFilterInputStream (wxInputStream *stream)
| Initializes a "filter" stream. More...
Public Member Functions inherited from wxInputStream
| wxInputStream ()
| Creates a dummy input stream. More...
virtual | ~wxInputStream ()
| Destructor. More...
virtual bool | CanRead () const
| Returns true if some data is available in the stream right now, so that calling Read() wouldn't block. More...
virtual bool | Eof () const
| Returns true after an attempt has been made to read past the end of the stream. More...
int | GetC ()
| Returns the first character in the input queue and removes it, blocking until it appears if necessary. More...
virtual size_t | LastRead () const
| Returns the last number of bytes read by the last input operation. More...
virtual char | Peek ()
| Returns the first character in the input queue without removing it. More...
virtual wxInputStream & | Read (void *buffer, size_t size)
| Reads the specified amount of bytes and stores the data in buffer. More...
wxInputStream & | Read (wxOutputStream &stream_out)
| Reads data from the input queue and stores it in the specified output stream. More...
bool | ReadAll (void *buffer, size_t size)
| Reads exactly the specified number of bytes into the buffer. More...
virtual wxFileOffset | SeekI (wxFileOffset pos, wxSeekMode mode=wxFromStart)
| Changes the stream current position. More...
virtual wxFileOffset | TellI () const
| Returns the current stream position or wxInvalidOffset if it's not available (e.g. More...
size_t | Ungetch (const void *buffer, size_t size)
| This function is only useful in read mode. More...
bool | Ungetch (char c)
| This function acts like the previous one except that it takes only one character: it is sometimes shorter to use than the generic function. More...
Public Member Functions inherited from wxStreamBase
| wxStreamBase ()
| Creates a dummy stream object. More...
virtual | ~wxStreamBase ()
| Destructor. More...
wxStreamError | GetLastError () const
| This function returns the last error. More...
virtual wxFileOffset | GetLength () const
| Returns the length of the stream in bytes. More...
virtual size_t | GetSize () const
| This function returns the size of the stream. More...
virtual bool | IsOk () const
| Returns true if no error occurred on the stream. More...
virtual bool | IsSeekable () const
| Returns true if the stream supports seeking to arbitrary offsets. More...
void | Reset (wxStreamError error=wxSTREAM_NO_ERROR)
| Resets the stream state. More...
bool | operator! () const
| Returns the opposite of IsOk(). More...

## Additional Inherited Members
Protected Member Functions inherited from wxInputStream
size_t | OnSysRead (void *buffer, size_t bufsize)=0
| Internal function. More...
Protected Member Functions inherited from wxStreamBase
virtual wxFileOffset | OnSysSeek (wxFileOffset pos, wxSeekMode mode)
| Internal function. More...
virtual wxFileOffset | OnSysTell () const
| Internal function. More...

## Constructor & Destructor Documentation

## ◆ wxZipInputStream() [1/2]

wxZipInputStream::wxZipInputStream | ( | wxInputStream & | stream,
|  | wxMBConv & | conv = `wxConvLocal`
| ) |  |

Constructor.

In a Unicode build the second parameter conv is used to translate the filename and comment fields into Unicode. It has no effect on the stream's data. If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

## ◆ wxZipInputStream() [2/2]

wxZipInputStream::wxZipInputStream | ( | wxInputStream * | stream,
|  | wxMBConv & | conv = `wxConvLocal`
| ) |  |

Constructor.

In a Unicode build the second parameter conv is used to translate the filename and comment fields into Unicode. It has no effect on the stream's data. If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

## Member Function Documentation

## ◆ CloseEntry()

bool wxZipInputStream::CloseEntry | ( |  | ) |
| virtual

Closes the current entry.

On a non-seekable stream reads to the end of the current entry first.

Implements wxArchiveInputStream.

## ◆ GetComment()

wxString wxZipInputStream::GetComment | ( |  | ) |

Returns the zip comment.

This is stored at the end of the zip, therefore when reading a zip from a non-seekable stream, it returns the empty string until the end of the zip has been reached, i.e. when GetNextEntry() returns nullptr.

## ◆ GetNextEntry()

wxZipEntry* wxZipInputStream::GetNextEntry | ( |  | ) |

Closes the current entry if one is open, then reads the meta-data for the next entry and returns it in a wxZipEntry object, giving away ownership.

The stream is then open and can be read.

## ◆ GetTotalEntries()

int wxZipInputStream::GetTotalEntries | ( |  | ) |

For a zip on a seekable stream returns the total number of entries in the zip.

For zips on non-seekable streams returns the number of entries returned so far by GetNextEntry().

## ◆ OpenEntry()

bool wxZipInputStream::OpenEntry | ( | wxZipEntry & | entry | ) |

Closes the current entry if one is open, then opens the entry specified by the entry object.

entry should be from the same zip file, and the zip should be on a seekable stream.

See also
  overview_archive_byname